
//--- Template class for arrays
template<typename T>
class TArray
{
protected:
   T        m_data[];
public:
   bool Append(T item)
   {
      int new_size=ArraySize(m_data)+1;
      int reserve =(new_size/2+15)&~15;

      if(ArrayResize(m_data,new_size,reserve)!=new_size)
         return(false);

      m_data[new_size-1]=item;
      return(true);
   }
   
   T operator[](int index)
   {
      static T invalid_index;

      if(index<0 || index>=ArraySize(m_data))
         return(invalid_index);

      return(m_data[index]);
     }  
};

//--- Declare template class of a pointer array to Class objects. 
//--- Destructor, deletes the objects, the pointers to which were stored in the array.
template<typename T>
class TArrayPtr : public TArray<T *>
{
public:
   void  ~TArrayPtr()
   {
      for(int n=0,count=ArraySize(m_data);n<count;n++)
         if(CheckPointer(m_data[n])==POINTER_DYNAMIC)
            delete m_data[n];
   }
   int   SizeOf()
   {
      return(ArraySize(m_data));
   }
};

//--- Events class
class CEvents
{
public:
   double   TargetPrice;

   CEvents( )  {};
   ~CEvents(void) {};

// MY NEMESIS:
//  ==========   
   void Initialise( TArrayPtr &MyArray )   
   {
   }
};

TArrayPtr   <CEvents>   M1PtrArray;
TArrayPtr   <CEvents>   M5PtrArray;
TArrayPtr   <CEvents>   M15PtrArray;

int OnInit()      { return(INIT_SUCCEEDED); }
bool OnNewBar()   {}  

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   if ( OnNewBar() )
   {
      CEvents *ptr = new CEvents();
      M1PtrArray.Append(ptr);
      ptr.Initialise( M1PtrArray );    // The other part of my Nemesis
   }
   return;
}
